@echo off
title Nexuiz Build System v0.1 - Quick Build
:beginning
echo.
echo Setting up environment...
echo Long path name: %CD%

for %%f in ("%CD%") do set BASE=%%~sf
set PATH=%PATH%;%BASE%\files\bin;%BASE%\files\msys\bin;%BASE%\files\unxutils\usr\local\wbin;%BASE%\files\svn-bin;%BASE%\files\SDL\bin

cd %BASE%

echo Short path name: %BASE%
echo.
tasklist /FI "IMAGENAME eq darkplaces.exe" 2>NUL | find /I /N "darkplaces.exe">NUL
if "%ERRORLEVEL%"=="0" echo WARNING: darkplaces.exe is running, not able to compile it!
echo.
if exist nexuiz\ (
  echo Checking if nexuiz\ folder exists... Yes
) else (
  echo Checking if nexuiz\ folder exists... No - Needs to be downloaded
)
if exist darkplaces\ (
  echo Checking if darkplaces\ folder exists... Yes
) else (
  echo Checking if darkplaces\ folder exists... No - Needs to be downloaded
)
if exist fteqcc\ (
  echo Checking if fteqcc\ folder exists... Yes
) else (
  echo Checking if fteqcc\ folder exists... No - Needs to be downloaded
)
if exist files\bin\ (
  echo Checking if files\bin\ folder exists... Yes
) else (
  echo Checking if files\bin\ folder exists... No 
  goto missingfiles
)
if exist files\include\ (
  echo Checking if files\include\ folder exists... Yes
) else (
  echo Checking if files\include\ folder exists... No 
  goto missingfiles
)
if exist files\lib\ (
  echo Checking if files\lib\ folder exists... Yes
) else (
  echo Checking if files\lib\ folder exists... No 
  goto missingfiles
)
if exist files\libexec\ (
  echo Checking if files\libexec\ folder exists... Yes
) else (
  echo Checking if files\libexec\ folder exists... No 
  goto missingfiles
)
if exist files\mingw32\ (
  echo Checking if files\mingw32\ folder exists... Yes
) else (
  echo Checking if files\mingw32\ folder exists... No 
  goto missingfiles
)
if exist files\msys\ (
  echo Checking if files\msys\ folder exists... Yes
) else (
  echo Checking if files\msys\ folder exists... No 
  goto missingfiles
)
if exist files\SDL\ (
  echo Checking if files\SDL\ folder exists... Yes
) else (
  echo Checking if files\SDL\ folder exists... No 
  goto missingfiles
)
if exist files\share\ (
  echo Checking if files\share\ folder exists... Yes
) else (
  echo Checking if files\share\ folder exists... No 
  goto missingfiles
)
if exist files\svn-bin\ (
  echo Checking if files\svn-bin\ folder exists... Yes
) else (
  echo Checking if files\svn-bin\ folder exists... No 
  goto missingfiles
)
echo.
echo.
echo Beginning...
echo. 
echo.
if exist run-wgl.bat ren run-wgl.bat run-wgl.dontrun
if exist run-sdl.bat ren run-sdl.bat run-sdl.dontrun

echo Downloading fteqcc...
call getsvn https://fteqw.svn.sourceforge.net/svnroot/fteqw/trunk/engine/qclib fteqcc
if errorlevel 1 goto bork

echo.
echo Downloading DarkPlaces...
call getsvn svn://svn.icculus.org/twilight/trunk/darkplaces/ darkplaces
if errorlevel 1 goto bork

echo.
echo Downloading Nexuiz...
call getsvn svn://svn.icculus.org/nexuiz/trunk/ nexuiz
if errorlevel 1 goto bork
echo.

if not exist fteqcc\ (
  echo *** ERROR: Cannot compile without FTEQCC, type build svn to fix this
  echo.
  goto bork
)
if not exist nexuiz\ (
  echo *** ERROR: Cannot compile without Nexuiz, type build svn to fix this
  echo.
  goto bork
)
if not exist darkplaces\ (
  echo *** ERROR: Cannot compile without Darkplaces, type build svn to fix this
  echo.
  goto bork
)
if exist run-wgl.bat ren run-wgl.bat run-wgl.dontrun
if exist run-sdl.bat ren run-sdl.bat run-sdl.dontrun

echo Compiling fteqcc...
cd fteqcc
make
if errorlevel 1 goto bork
copy /b fteqcc.bin fteqcc.exe
cd ..

set PATH=%PATH%;%BASE%/fteqcc

echo.
tasklist /FI "IMAGENAME eq darkplaces.exe" 2>NUL | find /I /N "darkplaces.exe">NUL
if "%ERRORLEVEL%"=="0" (
  echo Skipping Darkplaces... It is running at the moment!
) else (
  echo Compiling DarkPlaces...
  cd darkplaces
  make debug DP_MAKE_TARGET=mingw SDL_PREFIX="../files/SDL" CC=gcc 
  if errorlevel 1 goto bork
  cd ..
)

echo.
echo Compiling Nexuiz...
cd nexuiz\data
make FTEQCC="fteqcc" NEX_BUILDSYSTEM=1 clean all
if errorlevel 1 goto bork
cd ..\..

ren run-wgl.dontrun run-wgl.bat
ren run-sdl.dontrun run-sdl.bat

echo.
echo Done, compiled without errors.
exit
:missingfiles
echo.
echo *** ERROR: Missing important files, cannot continue! 
echo Package must be redownloaded, exiting.
pause
exit

:bork
endlocal
echo.
echo *** ERROR: Could not perform action (See above)
echo.
pause
exit