@echo off
title Nexuiz Build System v0.1
:beginning
echo.
echo Setting up environment...
echo Long path name: %CD%

for %%f in ("%CD%") do set BASE=%%~sf
set PATH=%PATH%;%BASE%\files\bin;%BASE%\files\msys\bin;%BASE%\files\unxutils\usr\local\wbin;%BASE%\files\svn-bin;%BASE%\files\SDL\bin

cd %BASE%

echo Short path name: %BASE%
echo.
tasklist /FI "IMAGENAME eq darkplaces.exe" 2>NUL | find /I /N "darkplaces.exe">NUL
if "%ERRORLEVEL%"=="0" echo WARNING: darkplaces.exe is running, not able to compile it!
echo.
if exist nexuiz\ (
  echo Checking if nexuiz\ folder exists... Yes
) else (
  echo Checking if nexuiz\ folder exists... No - Needs to be downloaded
)
if exist darkplaces\ (
  echo Checking if darkplaces\ folder exists... Yes
) else (
  echo Checking if darkplaces\ folder exists... No - Needs to be downloaded
)
if exist fteqcc\ (
  echo Checking if fteqcc\ folder exists... Yes
) else (
  echo Checking if fteqcc\ folder exists... No - Needs to be downloaded
)
if exist files\bin\ (
  echo Checking if files\bin\ folder exists... Yes
) else (
  echo Checking if files\bin\ folder exists... No 
  goto missingfiles
)
if exist files\include\ (
  echo Checking if files\include\ folder exists... Yes
) else (
  echo Checking if files\include\ folder exists... No 
  goto missingfiles
)
if exist files\lib\ (
  echo Checking if files\lib\ folder exists... Yes
) else (
  echo Checking if files\lib\ folder exists... No 
  goto missingfiles
)
if exist files\libexec\ (
  echo Checking if files\libexec\ folder exists... Yes
) else (
  echo Checking if files\libexec\ folder exists... No 
  goto missingfiles
)
if exist files\mingw32\ (
  echo Checking if files\mingw32\ folder exists... Yes
) else (
  echo Checking if files\mingw32\ folder exists... No 
  goto missingfiles
)
if exist files\msys\ (
  echo Checking if files\msys\ folder exists... Yes
) else (
  echo Checking if files\msys\ folder exists... No 
  goto missingfiles
)
if exist files\SDL\ (
  echo Checking if files\SDL\ folder exists... Yes
) else (
  echo Checking if files\SDL\ folder exists... No 
  goto missingfiles
)
if exist files\share\ (
  echo Checking if files\share\ folder exists... Yes
) else (
  echo Checking if files\share\ folder exists... No 
  goto missingfiles
)
if exist files\svn-bin\ (
  echo Checking if files\svn-bin\ folder exists... Yes
) else (
  echo Checking if files\svn-bin\ folder exists... No 
  goto missingfiles
)
echo. 
echo Done. Type help for command list.
echo.
echo.
echo.
:cmdlist
echo ================== Command List ===================
echo.
echo   build [svn/compile]
echo.
echo   patch [nex/dp/fteqcc] [apply/create]
echo.
echo   run [wgl/sdl]
echo.
echo   cleanup
echo.
echo   revert
echo.
echo   status
echo.
echo   help
echo.
echo   exit
echo.
echo ===================================================
echo   Type "build svn" to build the latest revision
echo         of Nexuiz/Darkplaces/fteqcc SVN.
echo ===================================================
echo.
goto prompt
:help
echo ===================================================
echo.
echo build [svn/compile]:
echo   svn: Download latest SVN, then compile it.
echo   compile: Compile local files.
echo.
echo patch [nex/dp/fteqcc] [apply/create]:
echo   apply: Apply a patch to target (nex/dp/fteqcc)
echo   create: Create a patch from files changed.
echo.
echo run [wgl/sdl]:
echo   wgl: Run the WGL version of Nexuiz
echo   sdl: Run the SDL version of Nexuiz
echo.
echo cleanup: Delete nex/dp/fteqcc folders.
echo.
echo revert: Revert any changed files back to normal.
echo.
echo status: Display checkout information.
echo.
echo 
echo ===================================================
echo.
goto prompt


:promptabort
echo *** Action aborted 
echo.
:prompt
endlocal
setLocal EnableDelayedExpansion
set input=nothing
set /P input="BuildSystem> "
if /I "!input!" == "exit" exit
if /I "!input!" == "nothing" goto prompt
echo.
if /I "!input!" == "help" goto help
if /I "!input!" == "cmdlist" goto cmdlist
if /I "!input!" == "cleanup" goto cleanup
if /I "!input!" == "revert" goto revert
if /I "!input!" == "status" goto status
if /I "!input!" == "run" goto runnexuiz
if /I "!input!" == "run wgl" goto runnexuizwgl
if /I "!input!" == "run sdl" goto runnexuizsdl
if /I "!input!" == "build" goto build
if /I "!input!" == "build svn" goto compilesvn
if /I "!input!" == "build compile" goto compile
if /I "!input!" == "build cmp" goto compile
if /I "!input!" == "clear" (
  cls
  goto prompt
)

:unknown
echo *** ERROR: Unknown Command: "!input!" (Does it have spaces?)
echo.
endlocal
goto prompt

:status
endlocal
if exist fteqcc\ ( svn info fteqcc ) else ( echo Missing FTEQCC! )
if exist darkplaces\ ( svn info darkplaces ) else ( echo Missing Darkplaces! )
if exist nexuiz\ ( svn info nexuiz ) else ( echo Missing Nexuiz! )
echo.
goto prompt

:build
endlocal
echo Do you want to build latest svn or compile local files?
set /P tempvar="[svn/compile/no]: "
echo.
if /I "%tempvar%" == "svn" goto compilesvn
if /I "%tempvar%" == "cmp" goto compile
if /I "%tempvar%" == "compile" goto compile
if /I "%tempvar%" == "no" goto promptabort
echo *** ERROR: Incorrect input
echo.
goto build

:compilesvn
endlocal
echo WARNING: This may take a long time, do you wish to build SVN?
set /P tempvar="[yes/no]: "
echo.
if /I "%tempvar%" == "yes" goto runcompilesvn
if /I "%tempvar%" == "y" goto runcompilesvn
if /I "%tempvar%" == "no" goto promptabort
if /I "%tempvar%" == "n" goto promptabort
echo *** ERROR: Incorrect input
echo.
goto compilesvn

:runcompilesvn
endlocal
if exist run-wgl.bat ren run-wgl.bat run-wgl.dontrun
if exist run-sdl.bat ren run-sdl.bat run-sdl.dontrun

echo Downloading fteqcc...
call getsvn https://fteqw.svn.sourceforge.net/svnroot/fteqw/trunk/engine/qclib fteqcc
if errorlevel 1 goto bork

echo.
echo Downloading DarkPlaces...
call getsvn svn://svn.icculus.org/twilight/trunk/darkplaces/ darkplaces
if errorlevel 1 goto bork

echo.
echo Downloading Nexuiz...
call getsvn svn://svn.icculus.org/nexuiz/trunk/ nexuiz
if errorlevel 1 goto bork
echo.
goto runcompile

:compile
endlocal
echo WARNING: This may take a long time, do you wish to compile?
set /P tempvar="[yes/no]: "
echo.
if /I "%tempvar%" == "yes" goto runcompile
if /I "%tempvar%" == "y" goto runcompile
if /I "%tempvar%" == "no" goto promptabort
if /I "%tempvar%" == "n" goto promptabort
echo *** ERROR: Incorrect input
echo.
goto compile

:runcompile
endlocal
if not exist fteqcc\ (
  echo *** ERROR: Cannot compile without FTEQCC, type build svn to fix this
  echo.
  goto promptabort
)
if not exist nexuiz\ (
  echo *** ERROR: Cannot compile without Nexuiz, type build svn to fix this
  echo.
  goto promptabort
)
if not exist darkplaces\ (
  echo *** ERROR: Cannot compile without Darkplaces, type build svn to fix this
  echo.
  goto promptabort
)
if exist run-wgl.bat ren run-wgl.bat run-wgl.dontrun
if exist run-sdl.bat ren run-sdl.bat run-sdl.dontrun

echo Compiling fteqcc...
cd fteqcc
make
if errorlevel 1 goto bork
copy /b fteqcc.bin fteqcc.exe
cd ..

set PATH=%PATH%;%BASE%/fteqcc

echo.
tasklist /FI "IMAGENAME eq darkplaces.exe" 2>NUL | find /I /N "darkplaces.exe">NUL
if "%ERRORLEVEL%"=="0" (
  echo Skipping Darkplaces... It is running at the moment!
) else (
  echo Compiling DarkPlaces...
  cd darkplaces
  make debug DP_MAKE_TARGET=mingw SDL_PREFIX="../files/SDL" CC=gcc 
  if errorlevel 1 goto bork
  cd ..
)

echo.
echo Compiling Nexuiz...
cd nexuiz\data
make FTEQCC="fteqcc" NEX_BUILDSYSTEM=1 clean all
if errorlevel 1 goto bork
cd ..\..

ren run-wgl.dontrun run-wgl.bat
ren run-sdl.dontrun run-sdl.bat

echo.
echo Done, compiled without errors. Do you want to run Nexuiz now? 
set /P tempvar="[yes/no]: "
echo.
if /I "%tempvar%" == "y" goto runnexuiz
if /I "%tempvar%" == "n" goto prompt
if /I "%tempvar%" == "yes" goto runnexuiz
if /I "%tempvar%" == "no" goto prompt
goto prompt

:cleanup
endlocal
echo WARNING: This command will delete all built and downloaded files!
echo.
echo Are you sure? 
set /P tempvar="[yes/no]: "
echo.
if /I "%tempvar%" == "y" goto cleanuprun
if /I "%tempvar%" == "n" goto promptabort
if /I "%tempvar%" == "yes" goto cleanuprun
if /I "%tempvar%" == "no" goto promptabort
echo *** ERROR: Incorrect input
echo.
goto cleanup

:revert
endlocal
echo WARNING: This command will remove all changes to the source code!
echo.
echo Are you sure? 
set /P tempvar="[yes/no]: "
echo.
if /I "%tempvar%" == "y" goto revertrun
if /I "%tempvar%" == "n" goto promptabort
if /I "%tempvar%" == "yes" goto revertrun
if /I "%tempvar%" == "no" goto promptabort
echo *** ERROR: Incorrect input
echo.
goto revert

:cleanuprun
endlocal
if exist run-wgl.bat ren run-wgl.bat run-wgl.dontrun
if exist run-sdl.bat ren run-sdl.bat run-sdl.dontrun
echo ===== Cleaning up... (This may take a while) =====
echo.
if exist fteqcc\ ( 
  echo Removing fteqcc\ files...
  rmdir /s /q fteqcc
  echo Done!
  echo.
) else (
  echo Skipping fteqcc\ files
  echo.
)
if exist darkplaces\ ( 
  echo Removing darkplaces\ files...
  rmdir /s /q darkplaces
  echo Done!
  echo.
) else (
  echo skipping nexuiz\ files
  echo.
)
if exist nexuiz\ ( 
  echo Removing nexuiz\ files...
  rmdir /s /q nexuiz
  echo Done!
  echo.
) else (
  echo skipping nexuiz\ files
  echo.
)
if errorlevel 1 goto bork
echo.
echo Cleaned up successfully.
echo.
goto prompt

:revertrun
endlocal
if exist run-wgl.bat ren run-wgl.bat run-wgl.dontrun
if exist run-sdl.bat ren run-sdl.bat run-sdl.dontrun
echo ===== Reverting files... (This may take a while) =====
echo.
if exist fteqcc\ ( 
  echo Reverting FTEQCC to its original state...
  svn revert -R fteqcc\
  echo Done!
  echo.
)
if exist darkplaces\ ( 
  echo Reverting Darkplaces to its original state...
  svn revert -R darkplaces\
  echo Done!
  echo.
)
if exist nexuiz\ ( 
  echo Reverting Nexuiz to its original state...
  svn revert -R nexuiz\
  echo Done!
  echo.
)
if errorlevel 1 goto bork
echo.
echo Reverted successfully.
echo.
goto revertcompile

:revertcompile
endlocal
echo Done, do you wish to recompile now that you have reverted? (Recommended)
set /P tempvar="[yes/no]: "
echo.
if /I "%tempvar%" == "y" goto runcompile
if /I "%tempvar%" == "n" goto prompt
if /I "%tempvar%" == "yes" goto runcompile
if /I "%tempvar%" == "no" goto prompt
echo *** ERROR: Incorrect input
echo.
goto revertcompile

:runnexuiz
endlocal
echo Which Nexuiz version? 
set /P tempvar="[wgl/sdl/cancel]: "
echo.
if /I "%tempvar%" == "sdl" goto runnexuizsdl
if /I "%tempvar%" == "wgl" goto runnexuizwgl
if /I "%tempvar%" == "cancel" goto promptabort
echo *** ERROR: Incorrect input
echo.
goto runnexuiz

:runnexuizwgl
start run-wgl.bat
exit

:runnexuizsdl
start run-sdl.bat
exit

:missingfiles
endlocal
echo.
echo *** ERROR: Missing important files, cannot continue! 
echo Package must be redownloaded, exiting.
pause
exit

:bork
endlocal
echo.
echo *** ERROR: Could not perform action (See above)
echo.
goto prompt